/**
 * config
 *
 * @module config
 *
 * @author Luca Pau <luca.pau82@gmail.com>
 */

'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _log = require('./log');

var _log2 = _interopRequireDefault(_log);

var _resultsPerPageMax = 100;
var _resultsPerPageDefault = 10;

exports['default'] = Object.defineProperties({}, {
  resultsPerPageMax: {
    get: function get() {
      return _resultsPerPageMax;
    },
    set: function set(resMax) {
      if (isNaN(resMax)) {
        _log2['default'].error('resultsPerPageMax require only integer');
        throw new TypeError('resultsPerPageMax require only integer');
      }

      _resultsPerPageMax = resMax;

      return this;
    },
    configurable: true,
    enumerable: true
  },
  resultsPerPageDefault: {
    get: function get() {
      return _resultsPerPageDefault;
    },
    set: function set(resDefault) {
      if (isNaN(resDefault)) {
        _log2['default'].error('resultsPerPageDefault require only integer');
        throw new TypeError('resultsPerPageDefault require only integer');
      }

      _resultsPerPageDefault = resDefault;

      return this;
    },
    configurable: true,
    enumerable: true
  }
});
module.exports = exports['default'];
