/**
 * AjaxCall
 *
 * A simple module for create a format between server and client
 *
 * @module AjaxCall
 *
 * @author Luca Pau <luca.pau82@gmail.com>
 */

'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

function _interopRequire(obj) { return obj && obj.__esModule ? obj['default'] : obj; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj['default'] = obj; return newObj; } }

var _models = require('./models');

var models = _interopRequireWildcard(_models);

var AjaxCallFactory = function AjaxCallFactory() {
  return new models.AjaxCall();
};
var AjaxListFactory = function AjaxListFactory() {
  return new models.AjaxList();
};
var AjaxFormCallFactory = function AjaxFormCallFactory() {
  return new models.AjaxFormCall();
};
var AjaxDataGridFactory = function AjaxDataGridFactory(totalItems, currentPage, totalPages, itemsPerPage) {
  return new models.AjaxDataGrid(totalItems, currentPage, totalPages, itemsPerPage);
};

var _log = require('./log');

Object.defineProperty(exports, 'setLogger', {
  enumerable: true,
  get: function get() {
    return _log.setLogger;
  }
});

var _config = require('./config');

exports.config = _interopRequire(_config);

var _middlewarePaginator = require('./middleware/paginator');

exports.paginatorMiddleware = _interopRequire(_middlewarePaginator);

var _helpersCalcPagination = require('./helpers/calcPagination');

exports.calcPagination = _interopRequire(_helpersCalcPagination);
exports.models = models;
exports.AjaxCallFactory = AjaxCallFactory;
exports.AjaxListFactory = AjaxListFactory;
exports.AjaxFormCallFactory = AjaxFormCallFactory;
exports.AjaxDataGridFactory = AjaxDataGridFactory;
