/**
 * di logger
 *
 * @module di logger
 *
 * @author Luca Pau <luca.pau82@gmail.com>
 */

"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
console.debug = console.trace;
console.fatal = console.error;
var _log = console;

exports["default"] = {
  getLogger: function getLogger() {
    return _log;
  },
  setLogger: function setLogger(log) {
    return _log = log;
  },
  trace: function trace(message) {
    return _log.trace(message);
  },
  info: function info(message) {
    return _log.info(message);
  },
  debug: function debug(message) {
    return _log.debug(message);
  },
  error: function error(message) {
    return _log.error(message);
  },
  fatal: function fatal(message) {
    return _log.fatal(message);
  }
};
module.exports = exports["default"];
