/**
 * paginator
 *
 * @module paginator
 *
 * @author Luca Pau <luca.pau82@gmail.com>
 */

'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = paginatorMiddleware;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _log = require('../log');

var _log2 = _interopRequireDefault(_log);

var _ = require('../');

function paginatorMiddleware(req, res, next) {
  var AjaxCall = (0, _.AjaxCallFactory)();
  try {
    var fields = req.body;

    if (!(fields.filters !== null && typeof fields.filters === 'object')) {
      return AjaxCall.sendErrorMessage(res, 400, 'Inconsistent data [filter not set]');
    }

    var orderBy = null;
    if (fields.orderBy) {
      _log2['default'].info('Paginator order by not implemented');
    }
    var paginator = {
      filters: fields.filters,
      currentPage: fields.page,
      itemsPerPage: fields.itemsPerPage,
      orderBy: orderBy
    };

    if (req.ajaxCall == null) {
      req.ajaxCall = {};
    }
    req.ajaxCall.paginator = paginator;
  } catch (err) {
    return AjaxCall.sendUnhandledExceptionMessage(res, err);
  }
  next();
}

module.exports = exports['default'];
