/**
 * AjaxDataGrid class
 *
 * @module AjaxDataGrid
 *
 * @author Luca Pau <luca.pau82@gmail.com>
 */

'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x9, _x10, _x11) { var _again = true; _function: while (_again) { var object = _x9, property = _x10, receiver = _x11; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x9 = parent; _x10 = property; _x11 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _AjaxList2 = require('./AjaxList');

var _AjaxList3 = _interopRequireDefault(_AjaxList2);

var _config = require('../config');

var _config2 = _interopRequireDefault(_config);

var _totalItems = Symbol();
var _currentPage = Symbol();
var _totalPages = Symbol();
var _itemsPerPage = Symbol();

/**
 * AjaxDataGrid class
 *
 * Perform ajax call for pagination
 *
 * @class AjaxDataGrid
 * @extends AjaxList
 */

var AjaxDataGrid = (function (_AjaxList) {
  _inherits(AjaxDataGrid, _AjaxList);

  /**
   * @constructor
   *
   * @param {int} [totalItems] total items
   * @param {int} [currentPage] current page
   * @param {int} [totalPages] total pages
   * @param {int} [itemsPerPage] number of items per page
   */

  function AjaxDataGrid() {
    var totalItems = arguments.length <= 0 || arguments[0] === undefined ? 0 : arguments[0];
    var currentPage = arguments.length <= 1 || arguments[1] === undefined ? 1 : arguments[1];
    var totalPages = arguments.length <= 2 || arguments[2] === undefined ? 0 : arguments[2];
    var itemsPerPage = arguments.length <= 3 || arguments[3] === undefined ? _config2['default'].resultsPerPageDefault : arguments[3];

    _classCallCheck(this, AjaxDataGrid);

    _get(Object.getPrototypeOf(AjaxDataGrid.prototype), 'constructor', this).call(this);
    this.totalItems = totalItems;
    this.currentPage = currentPage;
    this.totalPages = totalPages;
    this.itemsPerPage = itemsPerPage;
  }

  _createClass(AjaxDataGrid, [{
    key: 'reInit',
    value: function reInit() {
      var totalItems = arguments.length <= 0 || arguments[0] === undefined ? 0 : arguments[0];
      var currentPage = arguments.length <= 1 || arguments[1] === undefined ? 1 : arguments[1];
      var totalPages = arguments.length <= 2 || arguments[2] === undefined ? 0 : arguments[2];
      var itemsPerPage = arguments.length <= 3 || arguments[3] === undefined ? _config2['default'].resultsPerPageDefault : arguments[3];

      this.totalItems = totalItems;
      this.currentPage = currentPage;
      this.totalPages = totalPages;
      this.itemsPerPage = itemsPerPage;

      return this;
    }
  }, {
    key: 'getStruct',
    value: function getStruct() {
      var superStruct = _get(Object.getPrototypeOf(AjaxDataGrid.prototype), 'getStruct', this).call(this);
      superStruct.totalItems = this.totalItems;
      superStruct.currentPage = this.currentPage;
      superStruct.totalPages = this.totalPages;
      superStruct.itemsPerPage = this.itemsPerPage;

      return superStruct;
    }
  }, {
    key: 'totalItems',
    get: function get() {
      return this[_totalItems];
    },
    set: function set(totalItems) {
      if (typeof totalItems !== 'number') throw new TypeError('totalItems must be a number');

      this[_totalItems] = totalItems;
      return this;
    }
  }, {
    key: 'currentPage',
    get: function get() {
      return this[_currentPage];
    },
    set: function set(currentPage) {
      if (typeof currentPage !== 'number') throw new TypeError('currentPage must be a number');

      this[_currentPage] = currentPage;
      return this;
    }
  }, {
    key: 'totalPages',
    get: function get() {
      return this[_totalPages];
    },
    set: function set(totalPages) {
      if (typeof totalPages !== 'number') throw new TypeError('totalPages must be a number');

      this[_totalPages] = totalPages;
      return this;
    }
  }, {
    key: 'itemsPerPage',
    get: function get() {
      return this[_itemsPerPage];
    },
    set: function set(itemsPerPage) {
      if (typeof itemsPerPage !== 'number') throw new TypeError('itemsPerPage must be a number');

      this[_itemsPerPage] = itemsPerPage;
      return this;
    }
  }]);

  return AjaxDataGrid;
})(_AjaxList3['default']);

exports['default'] = AjaxDataGrid;
module.exports = exports['default'];
