/**
 * AjaxFormCall class
 *
 * @module AjaxFormCall
 *
 * @author Luca Pau <luca.pau82@gmail.com>
 */

'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _AjaxCall2 = require('./AjaxCall');

var _AjaxCall3 = _interopRequireDefault(_AjaxCall2);

var _errors = Symbol();
var _countErrors = Symbol();

/**
 * AjaxFormCall class
 *
 * Perform ajax call for forms
 *
 * @class AjaxFormCall
 * @extends AjaxCall
 */

var AjaxFormCall = (function (_AjaxCall) {
  _inherits(AjaxFormCall, _AjaxCall);

  /**
   * @constructor
   */

  function AjaxFormCall() {
    _classCallCheck(this, AjaxFormCall);

    _get(Object.getPrototypeOf(AjaxFormCall.prototype), 'constructor', this).call(this);
    this.errors = {};
    this.countErrors = 0;
  }

  _createClass(AjaxFormCall, [{
    key: 'hasError',
    value: function hasError() {
      return this.countErrors !== 0;
    }
  }, {
    key: 'addError',
    value: function addError(name, error) {
      this.result = 400;
      this.countErrors++;

      if (!(name in this.errors)) {
        this.errors[name] = [];
      }

      this.errors[name].push(error);

      return this;
    }
  }, {
    key: 'getStruct',
    value: function getStruct() {
      var superStruct = _get(Object.getPrototypeOf(AjaxFormCall.prototype), 'getStruct', this).call(this);
      superStruct.errors = this.errors;
      superStruct.countErrors = this.countErrors;

      return superStruct;
    }
  }, {
    key: 'errors',
    get: function get() {
      return this[_errors];
    },
    set: function set(errors) {
      this[_errors] = errors;
      return this;
    }
  }, {
    key: 'countErrors',
    get: function get() {
      return this[_countErrors];
    },
    set: function set(countErrors) {
      this[_countErrors] = countErrors;
      return this;
    }
  }]);

  return AjaxFormCall;
})(_AjaxCall3['default']);

exports['default'] = AjaxFormCall;
module.exports = exports['default'];
