/**
 * AjaxList class
 *
 * @module AjaxList
 *
 * @author Luca Pau <luca.pau82@gmail.com>
 */

'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i]; return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _AjaxCall2 = require('./AjaxCall');

var _AjaxCall3 = _interopRequireDefault(_AjaxCall2);

var _items = Symbol();
var _uniqueItems = Symbol();

var AjaxList = (function (_AjaxCall) {
  _inherits(AjaxList, _AjaxCall);

  function AjaxList() {
    _classCallCheck(this, AjaxList);

    _get(Object.getPrototypeOf(AjaxList.prototype), 'constructor', this).call(this);
    this.items = [];
    this[_uniqueItems] = new Set();
  }

  _createClass(AjaxList, [{
    key: 'addItem',
    value: function addItem(item) {
      this.items.push(item);
      return this;
    }
  }, {
    key: 'addUniqueItem',
    value: function addUniqueItem(uniqueItem) {
      this.uniqueItems.add(uniqueItem);
      return this;
    }
  }, {
    key: 'concatItems',
    value: function concatItems() {
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _len = arguments.length, items = Array(_len), _key = 0; _key < _len; _key++) {
          items[_key] = arguments[_key];
        }

        for (var _iterator = items[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var item = _step.value;

          this.items = this.items.concat(item);
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator['return']) {
            _iterator['return']();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      return this;
    }
  }, {
    key: 'getStruct',
    value: function getStruct() {
      var superStruct = _get(Object.getPrototypeOf(AjaxList.prototype), 'getStruct', this).call(this);
      superStruct.items = this.items;

      if (this.uniqueItems.size > 0) superStruct.uniqueItems = [].concat(_toConsumableArray(this.uniqueItems));

      return superStruct;
    }
  }, {
    key: 'items',
    get: function get() {
      return this[_items];
    },
    set: function set(items) {
      if (!Array.isArray(items)) throw new TypeError('Items must be array!');

      this[_items] = items;

      return this;
    }
  }, {
    key: 'uniqueItems',
    get: function get() {
      return this[_uniqueItems];
    },
    set: function set(uniqueItems) {
      if (Array.isArray(uniqueItems)) this[_uniqueItems] = new Set(uniqueItems);else {
        this.uniqueItems.clear();
        this.uniqueItems.add(uniqueItems);
      }

      return this;
    }
  }]);

  return AjaxList;
})(_AjaxCall3['default']);

exports['default'] = AjaxList;
module.exports = exports['default'];
